<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-261"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FBase%2FUtilsMacros.h%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/Base/UtilsMacros.h 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_utils_macros_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">UtilsMacros.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_utils_macros_8h.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  UtilsMacros.h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by zahir on 2017/6/12.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp;<span class="comment">// 全局工具类宏定义</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="preprocessor">#ifndef UtilsMacros_h</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="preprocessor">#define UtilsMacros_h</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp;<span class="preprocessor">#pragma mark - --------获取系统对象--------------</span></div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a548f04b3d1a2bc2c2b4f2c5a3035883c">   14</a></span>&nbsp;<span class="preprocessor">#define gApp                [UIApplication sharedApplication]</span></div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a3d0a080fbb01d0e29caf79d88338f957">   15</a></span>&nbsp;<span class="preprocessor">#define gRootVC             [UIApplication sharedApplication].delegate.window.rootViewController</span></div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#ad12989b812b8ba501ff0eeeb3364d95e">   16</a></span>&nbsp;<span class="preprocessor">#define gUserDefaults       [NSUserDefaults standardUserDefaults]</span></div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a853964dae0669c5f0b67fafacd013acf">   17</a></span>&nbsp;<span class="preprocessor">#define gNotifyCenter       [NSNotificationCenter defaultCenter]</span></div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#ac67f3b7cb189c16b513adb3d9748909f">   18</a></span>&nbsp;<span class="preprocessor">#define gDevice             [UIDevice currentDevice]</span></div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a122f811ff788c6f5ccc17d413f67a0e1">   19</a></span>&nbsp;<span class="preprocessor">#define gScreen             [UIScreen mainScreen]</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;<span class="comment">//适配小屏</span></div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a210ee0e58ed583bae8cc112adbf3b4eb">   21</a></span>&nbsp;<span class="preprocessor">#define kMaxWidth (kScreenHeight &gt; kScreenWidth ? kScreenHeight : kScreenWidth)</span></div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#abdb519fcdb0f5bced3ea2452e521e8b1">   22</a></span>&nbsp;<span class="preprocessor">#define MINSCREEN (kMaxWidth &lt; 600)</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;<span class="comment">//适配iPhone x</span></div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#afde53ca2c1289d72d5fb88eea60e67e9">   24</a></span>&nbsp;<span class="preprocessor">#define kDevice_Is_iPhoneX iPhoneX</span></div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a04489de138273eb826b8c7137bcf6ae5">   25</a></span>&nbsp;<span class="preprocessor">#define kVersionGreaterThanOrEqualTo(v)  \</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;<span class="preprocessor">([[UIDevice currentDevice].systemVersion compare:v options:NSNumericSearch] != NSOrderedAscending)</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp; </div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a0cf08b20e0753cb224a6bdcef4902af5">   28</a></span>&nbsp;<span class="preprocessor">#define gStatusBarHeight    [[UIApplication sharedApplication] statusBarFrame].size.height</span></div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a0a09a15c1d18aaa59b32809ea2198835">   29</a></span>&nbsp;<span class="preprocessor">#define gNavBarHeight 44.0</span></div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a608239176f10a194176cd5c1344289c8">   30</a></span>&nbsp;<span class="preprocessor">#define gTabbarHeight (kStatusBarHeight &gt; 20 ? 83:49)</span></div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#af35f788649c2f5cec642f6c28ada5ddf">   31</a></span>&nbsp;<span class="preprocessor">#define gNavigationBarHeight (gStatusBarHeight + gNavBarHeight)</span></div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a0f3912dbc7504900c6bcb2d4a35e22b4">   32</a></span>&nbsp;<span class="preprocessor">#define gSafeBottomHeight (kDevice_Is_iPhoneX ? 34:0)</span></div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a5433e03a21705bfb985237142e850e10">   33</a></span>&nbsp;<span class="preprocessor">#define gWebNavigationBarHeight  kDevice_Is_iPhoneX ? (44 + 20) : 20</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp; </div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a953a8d702dbddbece4f1401e9f1d5956">   35</a></span>&nbsp;<span class="preprocessor">#define gIpad  ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad)</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;<span class="comment">//App 版本号</span></div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#ad1a157d38b212c04911c55d09db5b0dc">   38</a></span>&nbsp;<span class="preprocessor">#define gAPPVERSION         [[[NSBundle mainBundle] infoDictionary] objectForKey:@&#34;CFBundleShortVersionString&#34;]</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;<span class="preprocessor">#pragma mark - --------屏幕相关--------------</span></div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a9a73d343dd1af7bfb763a047fedebe4c">   40</a></span>&nbsp;<span class="preprocessor">#define kScreenWidth    [[UIScreen mainScreen] bounds].size.width</span></div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a6227975f53b2543d4679ba2405decfb3">   41</a></span>&nbsp;<span class="preprocessor">#define kScreenHeight   [[UIScreen mainScreen] bounds].size.height</span></div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#ac9774310858be08fa6885fdf208dcd1b">   42</a></span>&nbsp;<span class="preprocessor">#define Iphone6WidthScale   kScreenWidth/375.0</span></div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a522c5b466fa01f13f6e876fe72d5203b">   43</a></span>&nbsp;<span class="preprocessor">#define Iphone6HeightScale  kScreenHeight/667.0</span></div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a88f3ef8c98351f405c09fc1e44b6a2df">   44</a></span>&nbsp;<span class="preprocessor">#define kFitWidthScale      MIN(kScreenWidth/375.0, 1)</span></div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a61cd8745dc97d8d8aa1aa72ab0c39531">   45</a></span>&nbsp;<span class="preprocessor">#define kFitHeightScale      MIN(kScreenHeight/667.0, 1)</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;<span class="preprocessor">#pragma mark - --------字体相关--------------</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;<span class="comment">// 加粗系统字体</span></div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a12f838b3e076407655a50b88689608d6">   49</a></span>&nbsp;<span class="preprocessor">#define BoldFont(size) [UIFont boldSystemFontOfSize:size]</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;<span class="comment">//默认系统字体</span></div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a178f12aa22fed21cbd4be7b1be0d846a">   51</a></span>&nbsp;<span class="preprocessor">#define Font(size) [UIFont systemFontOfSize:size]</span></div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a90ce666df00af4b5d9241613ba0c4b8a">   52</a></span>&nbsp;<span class="preprocessor">#define PingFangFont(name, tsize) \</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;<span class="preprocessor">({\</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;<span class="preprocessor">    UIFont *font = [UIFont systemFontOfSize:tsize];\</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;<span class="preprocessor">    if([[UIDevice currentDevice].systemVersion compare:@&#34;9.0&#34; options:NSNumericSearch] != NSOrderedAscending) {\</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;<span class="preprocessor">        font = [UIFont fontWithName:name size:tsize];\</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;<span class="preprocessor">    }\</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;<span class="preprocessor">    (font);\</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;<span class="preprocessor">})</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;<span class="comment">//  直播间消息文字大小(适配版)</span></div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#ae714125bc8522a2f6cfe73d4b210d62a">   63</a></span>&nbsp;<span class="preprocessor">#define kChatMessageFont  (gIpad ? Font(14) : Font(12))</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;<span class="preprocessor">#pragma mark - --------字符串相关--------------</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;<span class="comment">// 字符串格式化</span></div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a4336f22a021b2a1ef2d47206d4b1531f">   66</a></span>&nbsp;<span class="preprocessor">#define StringFormat(format,...) [NSString stringWithFormat:format,##__VA_ARGS__]</span></div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a188e8601d34bfe12a9990b7a40208609">   67</a></span>&nbsp;<span class="preprocessor">#define SafetyString(str) (str ? str : @&#34;&#34;)</span></div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a018d0bf979112eef1030aab40bd222e9">   68</a></span>&nbsp;<span class="preprocessor">#define AttString(str, att)  [[NSAttributedString alloc] initWithString:str attributes:att]</span></div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#abb5d646a25566fabd7b7efa7fb9b39d0">   69</a></span>&nbsp;<span class="preprocessor">#define URL(str) (str ? [NSURL URLWithString:str] : nil)</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp; </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp;<span class="preprocessor">#pragma mark - ---------图片相关---------------</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;<span class="preprocessor">#define Image(name) [UIImage imageNamed:name]</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;<span class="preprocessor">#pragma mark - ---------数据验证---------------</span></div>
<div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a1f347a8309411160e600cfac7df0fbd4">   76</a></span>&nbsp;<span class="preprocessor">#define VaildString(f) StrValid(f)</span></div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a02340989ddf95bdd46c1ff2c04e0d4c5">   77</a></span>&nbsp;<span class="preprocessor">#define VaildDictionary(f) (f!=nil &amp;&amp; [f isKindOfClass:[NSDictionary class]])</span></div>
<div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#aff17988710919007e7e336a116e75ad6">   78</a></span>&nbsp;<span class="preprocessor">#define ValidArray(f) (f!=nil &amp;&amp; [f isKindOfClass:[NSArray class]] &amp;&amp; [f count]&gt;0)</span></div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a45c26e3afe45239a8b1855a95f97714a">   79</a></span>&nbsp;<span class="preprocessor">#define ValidNumber(f) (f!=nil &amp;&amp; [f isKindOfClass:[NSNumber class]])</span></div>
<div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a45f6ee4b2f7f9e66b018a87426cd7fcf">   80</a></span>&nbsp;<span class="preprocessor">#define ValidClass(f,cls) (f!=nil &amp;&amp; [f isKindOfClass:[cls class]])</span></div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a2f18775e5e4d4856fa763dab282c04bb">   81</a></span>&nbsp;<span class="preprocessor">#define ValidData(f) (f!=nil &amp;&amp; [f isKindOfClass:[NSData class]])</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp; </div>
<div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#aa8c4e7d66e2551fed8466630e12857a1">   84</a></span>&nbsp;<span class="preprocessor">#define kXHXAppVersion @&#34;xhx/autoLogin/AppVersion&#34;</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&nbsp; </div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a0a1efb571af034c349070aec3d9beed8">   87</a></span>&nbsp;<span class="preprocessor">#define XHXSuppressPerformSelectorLeakWarning(Stuff) \</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&nbsp;<span class="preprocessor">do { \</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&nbsp;<span class="preprocessor">_Pragma(&#34;clang diagnostic push&#34;) \</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&nbsp;<span class="preprocessor">_Pragma(&#34;clang diagnostic ignored \&#34;-Warc-performSelector-leaks\&#34;&#34;) \</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&nbsp;<span class="preprocessor">Stuff; \</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&nbsp;<span class="preprocessor">_Pragma(&#34;clang diagnostic pop&#34;) \</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&nbsp;<span class="preprocessor">} while (0)</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&nbsp; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&nbsp;<span class="preprocessor">#endif </span><span class="comment">/* UtilsMacros_h */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&nbsp; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&nbsp; </div>
<div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="_utils_macros_8h.html#a60fbe30948e8665753d1faea48c46e33">   98</a></span>&nbsp;<span class="preprocessor">#define  adjustsScrollViewInsets_NO(scrollView,vc)\</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&nbsp;<span class="preprocessor">do { \</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&nbsp;<span class="preprocessor">_Pragma(&#34;clang diagnostic push&#34;) \</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&nbsp;<span class="preprocessor">_Pragma(&#34;clang diagnostic ignored \&#34;-Warc-performSelector-leaks\&#34;&#34;) \</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&nbsp;<span class="preprocessor">if ([UIScrollView instancesRespondToSelector:NSSelectorFromString(@&#34;setContentInsetAdjustmentBehavior:&#34;)]) {\</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&nbsp;<span class="preprocessor">NSMethodSignature *signature = [UIScrollView instanceMethodSignatureForSelector:@selector(setContentInsetAdjustmentBehavior:)];\</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&nbsp;<span class="preprocessor">NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:signature];\</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&nbsp;<span class="preprocessor">NSInteger argumet = 2;\</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&nbsp;<span class="preprocessor">invocation.target = scrollView;\</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&nbsp;<span class="preprocessor">invocation.selector = @selector(setContentInsetAdjustmentBehavior:);\</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&nbsp;<span class="preprocessor">[invocation setArgument:&amp;argumet atIndex:2];\</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&nbsp;<span class="preprocessor">[invocation invoke];\</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&nbsp;<span class="preprocessor">} else {\</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&nbsp;<span class="preprocessor">vc.automaticallyAdjustsScrollViewInsets = NO;\</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&nbsp;<span class="preprocessor">}\</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&nbsp;<span class="preprocessor">_Pragma(&#34;clang diagnostic pop&#34;) \</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&nbsp;<span class="preprocessor">} while (0)</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_e594291297641f362044084ee3bd79c2.html">Base</a></li><li class="navelem"><a class="el" href="_utils_macros_8h.html">UtilsMacros.h</a></li>
    <li class="footer">制作者 <a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20 </li>
  </ul>
</div>


</body></html>